/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-31 at 17:37:43 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.shopping.model;

/**
 * Model definition for ShoppingModelProductJsonV1.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Search API For Shopping. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ShoppingModelProductJsonV1 extends com.google.api.client.json.GenericJson {

  /**
   * Attributes of product (available only with a cx source).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Attributes> attributes;

  static {
    // hack to force ProGuard to consider Attributes used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Attributes.class);
  }

  /**
   * Author of product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Author author;

  /**
   * Brand of product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String brand;

  /**
   * Categories of product according to the selected taxonomy, omitted if no taxonomy is selected.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> categories;

  /**
   * Condition of product (one of: new, refurbished, used).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String condition;

  /**
   * ISO 3166 code of target country of product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String country;

  /**
   * RFC 3339 formatted creation time and date of product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime creationTime;

  /**
   * Description of product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * Google id of product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.math.BigInteger googleId;

  /**
   * The first GTIN of the product. Deprecated in favor of "gtins".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String gtin;

  /**
   * List of all the product's GTINs (in GTIN-14 format).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> gtins;

  /**
   * Images of product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Images> images;

  static {
    // hack to force ProGuard to consider Images used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Images.class);
  }

  /**
   * Google Internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> internal1;

  /**
   * Google Internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> internal10;

  /**
   * Google Internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String internal12;

  /**
   * Google Internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double internal13;

  /**
   * Google Internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double internal14;

  /**
   * Google Internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double internal15;

  /**
   * Google Internal. Attribute names are deliberately vague.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Internal16 internal16;

  /**
   * Google Internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String internal3;

  /**
   * Google Internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Internal4> internal4;

  static {
    // hack to force ProGuard to consider Internal4 used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Internal4.class);
  }

  /**
   * Google Internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String internal6;

  /**
   * Google Internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean internal7;

  /**
   * Google Internal.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> internal8;

  /**
   * Inventories of product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Inventories> inventories;

  static {
    // hack to force ProGuard to consider Inventories used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Inventories.class);
  }

  /**
   * BCP 47 language tag of language of product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String language;

  /**
   * Link to product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String link;

  /**
   * RFC 3339 formatted modification time and date of product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime modificationTime;

  /**
   * List of all the product's MPNs.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> mpns;

  /**
   * Code to add to the page to render the +1 content.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String plusOne;

  /**
   * Merchant-provided id of product (available only with a cx source).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String providedId;

  /**
   * Whether this product matched the user query. Only set for the variant offers (if any) attached
   * to a product offer.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean queryMatched;

  /**
   * Google Internal
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Float score;

  /**
   * Title of product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * The number of variant offers returned that matched the query.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer totalMatchingVariants;

  /**
   * A list of variant offers associated with this product.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Variants> variants;

  static {
    // hack to force ProGuard to consider Variants used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Variants.class);
  }

  /**
   * Attributes of product (available only with a cx source).
   * @return value or {@code null} for none
   */
  public java.util.List<Attributes> getAttributes() {
    return attributes;
  }

  /**
   * Attributes of product (available only with a cx source).
   * @param attributes attributes or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setAttributes(java.util.List<Attributes> attributes) {
    this.attributes = attributes;
    return this;
  }

  /**
   * Author of product.
   * @return value or {@code null} for none
   */
  public Author getAuthor() {
    return author;
  }

  /**
   * Author of product.
   * @param author author or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setAuthor(Author author) {
    this.author = author;
    return this;
  }

  /**
   * Brand of product.
   * @return value or {@code null} for none
   */
  public java.lang.String getBrand() {
    return brand;
  }

  /**
   * Brand of product.
   * @param brand brand or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setBrand(java.lang.String brand) {
    this.brand = brand;
    return this;
  }

  /**
   * Categories of product according to the selected taxonomy, omitted if no taxonomy is selected.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getCategories() {
    return categories;
  }

  /**
   * Categories of product according to the selected taxonomy, omitted if no taxonomy is selected.
   * @param categories categories or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setCategories(java.util.List<java.lang.String> categories) {
    this.categories = categories;
    return this;
  }

  /**
   * Condition of product (one of: new, refurbished, used).
   * @return value or {@code null} for none
   */
  public java.lang.String getCondition() {
    return condition;
  }

  /**
   * Condition of product (one of: new, refurbished, used).
   * @param condition condition or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setCondition(java.lang.String condition) {
    this.condition = condition;
    return this;
  }

  /**
   * ISO 3166 code of target country of product.
   * @return value or {@code null} for none
   */
  public java.lang.String getCountry() {
    return country;
  }

  /**
   * ISO 3166 code of target country of product.
   * @param country country or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setCountry(java.lang.String country) {
    this.country = country;
    return this;
  }

  /**
   * RFC 3339 formatted creation time and date of product.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getCreationTime() {
    return creationTime;
  }

  /**
   * RFC 3339 formatted creation time and date of product.
   * @param creationTime creationTime or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setCreationTime(com.google.api.client.util.DateTime creationTime) {
    this.creationTime = creationTime;
    return this;
  }

  /**
   * Description of product.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * Description of product.
   * @param description description or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * Google id of product.
   * @return value or {@code null} for none
   */
  public java.math.BigInteger getGoogleId() {
    return googleId;
  }

  /**
   * Google id of product.
   * @param googleId googleId or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setGoogleId(java.math.BigInteger googleId) {
    this.googleId = googleId;
    return this;
  }

  /**
   * The first GTIN of the product. Deprecated in favor of "gtins".
   * @return value or {@code null} for none
   */
  public java.lang.String getGtin() {
    return gtin;
  }

  /**
   * The first GTIN of the product. Deprecated in favor of "gtins".
   * @param gtin gtin or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setGtin(java.lang.String gtin) {
    this.gtin = gtin;
    return this;
  }

  /**
   * List of all the product's GTINs (in GTIN-14 format).
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getGtins() {
    return gtins;
  }

  /**
   * List of all the product's GTINs (in GTIN-14 format).
   * @param gtins gtins or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setGtins(java.util.List<java.lang.String> gtins) {
    this.gtins = gtins;
    return this;
  }

  /**
   * Images of product.
   * @return value or {@code null} for none
   */
  public java.util.List<Images> getImages() {
    return images;
  }

  /**
   * Images of product.
   * @param images images or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setImages(java.util.List<Images> images) {
    this.images = images;
    return this;
  }

  /**
   * Google Internal.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getInternal1() {
    return internal1;
  }

  /**
   * Google Internal.
   * @param internal1 internal1 or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setInternal1(java.util.List<java.lang.String> internal1) {
    this.internal1 = internal1;
    return this;
  }

  /**
   * Google Internal.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getInternal10() {
    return internal10;
  }

  /**
   * Google Internal.
   * @param internal10 internal10 or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setInternal10(java.util.List<java.lang.String> internal10) {
    this.internal10 = internal10;
    return this;
  }

  /**
   * Google Internal.
   * @return value or {@code null} for none
   */
  public java.lang.String getInternal12() {
    return internal12;
  }

  /**
   * Google Internal.
   * @param internal12 internal12 or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setInternal12(java.lang.String internal12) {
    this.internal12 = internal12;
    return this;
  }

  /**
   * Google Internal.
   * @return value or {@code null} for none
   */
  public java.lang.Double getInternal13() {
    return internal13;
  }

  /**
   * Google Internal.
   * @param internal13 internal13 or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setInternal13(java.lang.Double internal13) {
    this.internal13 = internal13;
    return this;
  }

  /**
   * Google Internal.
   * @return value or {@code null} for none
   */
  public java.lang.Double getInternal14() {
    return internal14;
  }

  /**
   * Google Internal.
   * @param internal14 internal14 or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setInternal14(java.lang.Double internal14) {
    this.internal14 = internal14;
    return this;
  }

  /**
   * Google Internal.
   * @return value or {@code null} for none
   */
  public java.lang.Double getInternal15() {
    return internal15;
  }

  /**
   * Google Internal.
   * @param internal15 internal15 or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setInternal15(java.lang.Double internal15) {
    this.internal15 = internal15;
    return this;
  }

  /**
   * Google Internal. Attribute names are deliberately vague.
   * @return value or {@code null} for none
   */
  public Internal16 getInternal16() {
    return internal16;
  }

  /**
   * Google Internal. Attribute names are deliberately vague.
   * @param internal16 internal16 or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setInternal16(Internal16 internal16) {
    this.internal16 = internal16;
    return this;
  }

  /**
   * Google Internal.
   * @return value or {@code null} for none
   */
  public java.lang.String getInternal3() {
    return internal3;
  }

  /**
   * Google Internal.
   * @param internal3 internal3 or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setInternal3(java.lang.String internal3) {
    this.internal3 = internal3;
    return this;
  }

  /**
   * Google Internal.
   * @return value or {@code null} for none
   */
  public java.util.List<Internal4> getInternal4() {
    return internal4;
  }

  /**
   * Google Internal.
   * @param internal4 internal4 or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setInternal4(java.util.List<Internal4> internal4) {
    this.internal4 = internal4;
    return this;
  }

  /**
   * Google Internal.
   * @return value or {@code null} for none
   */
  public java.lang.String getInternal6() {
    return internal6;
  }

  /**
   * Google Internal.
   * @param internal6 internal6 or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setInternal6(java.lang.String internal6) {
    this.internal6 = internal6;
    return this;
  }

  /**
   * Google Internal.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getInternal7() {
    return internal7;
  }

  /**
   * Google Internal.
   * @param internal7 internal7 or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setInternal7(java.lang.Boolean internal7) {
    this.internal7 = internal7;
    return this;
  }

  /**
   * Google Internal.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getInternal8() {
    return internal8;
  }

  /**
   * Google Internal.
   * @param internal8 internal8 or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setInternal8(java.util.List<java.lang.String> internal8) {
    this.internal8 = internal8;
    return this;
  }

  /**
   * Inventories of product.
   * @return value or {@code null} for none
   */
  public java.util.List<Inventories> getInventories() {
    return inventories;
  }

  /**
   * Inventories of product.
   * @param inventories inventories or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setInventories(java.util.List<Inventories> inventories) {
    this.inventories = inventories;
    return this;
  }

  /**
   * BCP 47 language tag of language of product.
   * @return value or {@code null} for none
   */
  public java.lang.String getLanguage() {
    return language;
  }

  /**
   * BCP 47 language tag of language of product.
   * @param language language or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setLanguage(java.lang.String language) {
    this.language = language;
    return this;
  }

  /**
   * Link to product.
   * @return value or {@code null} for none
   */
  public java.lang.String getLink() {
    return link;
  }

  /**
   * Link to product.
   * @param link link or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setLink(java.lang.String link) {
    this.link = link;
    return this;
  }

  /**
   * RFC 3339 formatted modification time and date of product.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getModificationTime() {
    return modificationTime;
  }

  /**
   * RFC 3339 formatted modification time and date of product.
   * @param modificationTime modificationTime or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setModificationTime(com.google.api.client.util.DateTime modificationTime) {
    this.modificationTime = modificationTime;
    return this;
  }

  /**
   * List of all the product's MPNs.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getMpns() {
    return mpns;
  }

  /**
   * List of all the product's MPNs.
   * @param mpns mpns or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setMpns(java.util.List<java.lang.String> mpns) {
    this.mpns = mpns;
    return this;
  }

  /**
   * Code to add to the page to render the +1 content.
   * @return value or {@code null} for none
   */
  public java.lang.String getPlusOne() {
    return plusOne;
  }

  /**
   * Code to add to the page to render the +1 content.
   * @param plusOne plusOne or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setPlusOne(java.lang.String plusOne) {
    this.plusOne = plusOne;
    return this;
  }

  /**
   * Merchant-provided id of product (available only with a cx source).
   * @return value or {@code null} for none
   */
  public java.lang.String getProvidedId() {
    return providedId;
  }

  /**
   * Merchant-provided id of product (available only with a cx source).
   * @param providedId providedId or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setProvidedId(java.lang.String providedId) {
    this.providedId = providedId;
    return this;
  }

  /**
   * Whether this product matched the user query. Only set for the variant offers (if any) attached
   * to a product offer.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getQueryMatched() {
    return queryMatched;
  }

  /**
   * Whether this product matched the user query. Only set for the variant offers (if any) attached
   * to a product offer.
   * @param queryMatched queryMatched or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setQueryMatched(java.lang.Boolean queryMatched) {
    this.queryMatched = queryMatched;
    return this;
  }

  /**
   * Google Internal
   * @return value or {@code null} for none
   */
  public java.lang.Float getScore() {
    return score;
  }

  /**
   * Google Internal
   * @param score score or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setScore(java.lang.Float score) {
    this.score = score;
    return this;
  }

  /**
   * Title of product.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * Title of product.
   * @param title title or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  /**
   * The number of variant offers returned that matched the query.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getTotalMatchingVariants() {
    return totalMatchingVariants;
  }

  /**
   * The number of variant offers returned that matched the query.
   * @param totalMatchingVariants totalMatchingVariants or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setTotalMatchingVariants(java.lang.Integer totalMatchingVariants) {
    this.totalMatchingVariants = totalMatchingVariants;
    return this;
  }

  /**
   * A list of variant offers associated with this product.
   * @return value or {@code null} for none
   */
  public java.util.List<Variants> getVariants() {
    return variants;
  }

  /**
   * A list of variant offers associated with this product.
   * @param variants variants or {@code null} for none
   */
  public ShoppingModelProductJsonV1 setVariants(java.util.List<Variants> variants) {
    this.variants = variants;
    return this;
  }

  @Override
  public ShoppingModelProductJsonV1 set(String fieldName, Object value) {
    return (ShoppingModelProductJsonV1) super.set(fieldName, value);
  }

  @Override
  public ShoppingModelProductJsonV1 clone() {
    return (ShoppingModelProductJsonV1) super.clone();
  }

  /**
   * Model definition for ShoppingModelProductJsonV1Attributes.
   */
  public static final class Attributes extends com.google.api.client.json.GenericJson {

    /**
     * Display Name of prodct attribute.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String displayName;

    /**
     * Name of product attribute.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String name;

    /**
     * Type of product attribute (one of: text, bool, int, float, dateRange, url).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String type;

    /**
     * Unit of product attribute.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String unit;

    /**
     * Value of product attribute.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Object value;

    /**
     * Display Name of prodct attribute.
     * @return value or {@code null} for none
     */
    public java.lang.String getDisplayName() {
      return displayName;
    }

    /**
     * Display Name of prodct attribute.
     * @param displayName displayName or {@code null} for none
     */
    public Attributes setDisplayName(java.lang.String displayName) {
      this.displayName = displayName;
      return this;
    }

    /**
     * Name of product attribute.
     * @return value or {@code null} for none
     */
    public java.lang.String getName() {
      return name;
    }

    /**
     * Name of product attribute.
     * @param name name or {@code null} for none
     */
    public Attributes setName(java.lang.String name) {
      this.name = name;
      return this;
    }

    /**
     * Type of product attribute (one of: text, bool, int, float, dateRange, url).
     * @return value or {@code null} for none
     */
    public java.lang.String getType() {
      return type;
    }

    /**
     * Type of product attribute (one of: text, bool, int, float, dateRange, url).
     * @param type type or {@code null} for none
     */
    public Attributes setType(java.lang.String type) {
      this.type = type;
      return this;
    }

    /**
     * Unit of product attribute.
     * @return value or {@code null} for none
     */
    public java.lang.String getUnit() {
      return unit;
    }

    /**
     * Unit of product attribute.
     * @param unit unit or {@code null} for none
     */
    public Attributes setUnit(java.lang.String unit) {
      this.unit = unit;
      return this;
    }

    /**
     * Value of product attribute.
     * @return value or {@code null} for none
     */
    public java.lang.Object getValue() {
      return value;
    }

    /**
     * Value of product attribute.
     * @param value value or {@code null} for none
     */
    public Attributes setValue(java.lang.Object value) {
      this.value = value;
      return this;
    }

    @Override
    public Attributes set(String fieldName, Object value) {
      return (Attributes) super.set(fieldName, value);
    }

    @Override
    public Attributes clone() {
      return (Attributes) super.clone();
    }

  }

  /**
   * Author of product.
   */
  public static final class Author extends com.google.api.client.json.GenericJson {

    /**
     * Account id of product author.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.math.BigInteger accountId;

    /**
     * Name of product author.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String name;

    /**
     * Account id of product author.
     * @return value or {@code null} for none
     */
    public java.math.BigInteger getAccountId() {
      return accountId;
    }

    /**
     * Account id of product author.
     * @param accountId accountId or {@code null} for none
     */
    public Author setAccountId(java.math.BigInteger accountId) {
      this.accountId = accountId;
      return this;
    }

    /**
     * Name of product author.
     * @return value or {@code null} for none
     */
    public java.lang.String getName() {
      return name;
    }

    /**
     * Name of product author.
     * @param name name or {@code null} for none
     */
    public Author setName(java.lang.String name) {
      this.name = name;
      return this;
    }

    @Override
    public Author set(String fieldName, Object value) {
      return (Author) super.set(fieldName, value);
    }

    @Override
    public Author clone() {
      return (Author) super.clone();
    }

  }

  /**
   * Model definition for ShoppingModelProductJsonV1Images.
   */
  public static final class Images extends com.google.api.client.json.GenericJson {

    /**
     * Link to product image.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String link;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String status;

    /**
     * Thumbnails of product image.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<Thumbnails> thumbnails;

    static {
      // hack to force ProGuard to consider Thumbnails used, since otherwise it would be stripped out
      // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
      com.google.api.client.util.Data.nullOf(Thumbnails.class);
    }

    /**
     * Link to product image.
     * @return value or {@code null} for none
     */
    public java.lang.String getLink() {
      return link;
    }

    /**
     * Link to product image.
     * @param link link or {@code null} for none
     */
    public Images setLink(java.lang.String link) {
      this.link = link;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.String getStatus() {
      return status;
    }

    /**
     * @param status status or {@code null} for none
     */
    public Images setStatus(java.lang.String status) {
      this.status = status;
      return this;
    }

    /**
     * Thumbnails of product image.
     * @return value or {@code null} for none
     */
    public java.util.List<Thumbnails> getThumbnails() {
      return thumbnails;
    }

    /**
     * Thumbnails of product image.
     * @param thumbnails thumbnails or {@code null} for none
     */
    public Images setThumbnails(java.util.List<Thumbnails> thumbnails) {
      this.thumbnails = thumbnails;
      return this;
    }

    @Override
    public Images set(String fieldName, Object value) {
      return (Images) super.set(fieldName, value);
    }

    @Override
    public Images clone() {
      return (Images) super.clone();
    }

    /**
     * Model definition for ShoppingModelProductJsonV1ImagesThumbnails.
     */
    public static final class Thumbnails extends com.google.api.client.json.GenericJson {

      /**
       * Content of thumbnail (only available for the first thumbnail of the top results if SAYT is
       * enabled).
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.String content;

      /**
       * Height of thumbnail (omitted if not specified in the request).
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.Integer height;

      /**
       * Link to thumbnail.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.String link;

      /**
       * Width of thumbnail (omitted if not specified in the request).
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key
      private java.lang.Integer width;

      /**
       * Content of thumbnail (only available for the first thumbnail of the top results if SAYT is
       * enabled).
       * @return value or {@code null} for none
       */
      public java.lang.String getContent() {
        return content;
      }

      /**
       * Content of thumbnail (only available for the first thumbnail of the top results if SAYT is
       * enabled).
       * @param content content or {@code null} for none
       */
      public Thumbnails setContent(java.lang.String content) {
        this.content = content;
        return this;
      }

      /**
       * Height of thumbnail (omitted if not specified in the request).
       * @return value or {@code null} for none
       */
      public java.lang.Integer getHeight() {
        return height;
      }

      /**
       * Height of thumbnail (omitted if not specified in the request).
       * @param height height or {@code null} for none
       */
      public Thumbnails setHeight(java.lang.Integer height) {
        this.height = height;
        return this;
      }

      /**
       * Link to thumbnail.
       * @return value or {@code null} for none
       */
      public java.lang.String getLink() {
        return link;
      }

      /**
       * Link to thumbnail.
       * @param link link or {@code null} for none
       */
      public Thumbnails setLink(java.lang.String link) {
        this.link = link;
        return this;
      }

      /**
       * Width of thumbnail (omitted if not specified in the request).
       * @return value or {@code null} for none
       */
      public java.lang.Integer getWidth() {
        return width;
      }

      /**
       * Width of thumbnail (omitted if not specified in the request).
       * @param width width or {@code null} for none
       */
      public Thumbnails setWidth(java.lang.Integer width) {
        this.width = width;
        return this;
      }

      @Override
      public Thumbnails set(String fieldName, Object value) {
        return (Thumbnails) super.set(fieldName, value);
      }

      @Override
      public Thumbnails clone() {
        return (Thumbnails) super.clone();
      }

    }
  }

  /**
   * Google Internal. Attribute names are deliberately vague.
   */
  public static final class Internal16 extends com.google.api.client.json.GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer length;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer number;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long size;

    /**
     * @return value or {@code null} for none
     */
    public java.lang.Integer getLength() {
      return length;
    }

    /**
     * @param length length or {@code null} for none
     */
    public Internal16 setLength(java.lang.Integer length) {
      this.length = length;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.Integer getNumber() {
      return number;
    }

    /**
     * @param number number or {@code null} for none
     */
    public Internal16 setNumber(java.lang.Integer number) {
      this.number = number;
      return this;
    }

    /**
     * @return value or {@code null} for none
     */
    public java.lang.Long getSize() {
      return size;
    }

    /**
     * @param size size or {@code null} for none
     */
    public Internal16 setSize(java.lang.Long size) {
      this.size = size;
      return this;
    }

    @Override
    public Internal16 set(String fieldName, Object value) {
      return (Internal16) super.set(fieldName, value);
    }

    @Override
    public Internal16 clone() {
      return (Internal16) super.clone();
    }

  }

  /**
   * Model definition for ShoppingModelProductJsonV1Internal4.
   */
  public static final class Internal4 extends com.google.api.client.json.GenericJson {

    /**
     * Google Internal.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Double confidence;

    /**
     * Google Internal.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer node;

    /**
     * Google Internal.
     * @return value or {@code null} for none
     */
    public java.lang.Double getConfidence() {
      return confidence;
    }

    /**
     * Google Internal.
     * @param confidence confidence or {@code null} for none
     */
    public Internal4 setConfidence(java.lang.Double confidence) {
      this.confidence = confidence;
      return this;
    }

    /**
     * Google Internal.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getNode() {
      return node;
    }

    /**
     * Google Internal.
     * @param node node or {@code null} for none
     */
    public Internal4 setNode(java.lang.Integer node) {
      this.node = node;
      return this;
    }

    @Override
    public Internal4 set(String fieldName, Object value) {
      return (Internal4) super.set(fieldName, value);
    }

    @Override
    public Internal4 clone() {
      return (Internal4) super.clone();
    }

  }

  /**
   * Model definition for ShoppingModelProductJsonV1Inventories.
   */
  public static final class Inventories extends com.google.api.client.json.GenericJson {

    /**
     * Availability of product inventory.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String availability;

    /**
     * Channel of product inventory (one of: online, local).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String channel;

    /**
     * Currency of product inventory (an ISO 4217 alphabetic code).
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String currency;

    /**
     * Distance of product inventory.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Float distance;

    /**
     * Distance unit of product inventory.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String distanceUnit;

    /**
     * Number of months for installment price.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer installmentMonths;

    /**
     * Installment price of product inventory.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Float installmentPrice;

    /**
     * Original price of product inventory. Only returned for products that are on sale.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Float originalPrice;

    /**
     * Price of product inventory.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Float price;

    /**
     * Sale end date.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private com.google.api.client.util.DateTime saleEndDate;

    /**
     * Sale price of product inventory.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Float salePrice;

    /**
     * Sale start date.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private com.google.api.client.util.DateTime saleStartDate;

    /**
     * Shipping cost of product inventory.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Float shipping;

    /**
     * Store ID of product inventory.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String storeId;

    /**
     * Tax of product inventory.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Float tax;

    /**
     * Availability of product inventory.
     * @return value or {@code null} for none
     */
    public java.lang.String getAvailability() {
      return availability;
    }

    /**
     * Availability of product inventory.
     * @param availability availability or {@code null} for none
     */
    public Inventories setAvailability(java.lang.String availability) {
      this.availability = availability;
      return this;
    }

    /**
     * Channel of product inventory (one of: online, local).
     * @return value or {@code null} for none
     */
    public java.lang.String getChannel() {
      return channel;
    }

    /**
     * Channel of product inventory (one of: online, local).
     * @param channel channel or {@code null} for none
     */
    public Inventories setChannel(java.lang.String channel) {
      this.channel = channel;
      return this;
    }

    /**
     * Currency of product inventory (an ISO 4217 alphabetic code).
     * @return value or {@code null} for none
     */
    public java.lang.String getCurrency() {
      return currency;
    }

    /**
     * Currency of product inventory (an ISO 4217 alphabetic code).
     * @param currency currency or {@code null} for none
     */
    public Inventories setCurrency(java.lang.String currency) {
      this.currency = currency;
      return this;
    }

    /**
     * Distance of product inventory.
     * @return value or {@code null} for none
     */
    public java.lang.Float getDistance() {
      return distance;
    }

    /**
     * Distance of product inventory.
     * @param distance distance or {@code null} for none
     */
    public Inventories setDistance(java.lang.Float distance) {
      this.distance = distance;
      return this;
    }

    /**
     * Distance unit of product inventory.
     * @return value or {@code null} for none
     */
    public java.lang.String getDistanceUnit() {
      return distanceUnit;
    }

    /**
     * Distance unit of product inventory.
     * @param distanceUnit distanceUnit or {@code null} for none
     */
    public Inventories setDistanceUnit(java.lang.String distanceUnit) {
      this.distanceUnit = distanceUnit;
      return this;
    }

    /**
     * Number of months for installment price.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getInstallmentMonths() {
      return installmentMonths;
    }

    /**
     * Number of months for installment price.
     * @param installmentMonths installmentMonths or {@code null} for none
     */
    public Inventories setInstallmentMonths(java.lang.Integer installmentMonths) {
      this.installmentMonths = installmentMonths;
      return this;
    }

    /**
     * Installment price of product inventory.
     * @return value or {@code null} for none
     */
    public java.lang.Float getInstallmentPrice() {
      return installmentPrice;
    }

    /**
     * Installment price of product inventory.
     * @param installmentPrice installmentPrice or {@code null} for none
     */
    public Inventories setInstallmentPrice(java.lang.Float installmentPrice) {
      this.installmentPrice = installmentPrice;
      return this;
    }

    /**
     * Original price of product inventory. Only returned for products that are on sale.
     * @return value or {@code null} for none
     */
    public java.lang.Float getOriginalPrice() {
      return originalPrice;
    }

    /**
     * Original price of product inventory. Only returned for products that are on sale.
     * @param originalPrice originalPrice or {@code null} for none
     */
    public Inventories setOriginalPrice(java.lang.Float originalPrice) {
      this.originalPrice = originalPrice;
      return this;
    }

    /**
     * Price of product inventory.
     * @return value or {@code null} for none
     */
    public java.lang.Float getPrice() {
      return price;
    }

    /**
     * Price of product inventory.
     * @param price price or {@code null} for none
     */
    public Inventories setPrice(java.lang.Float price) {
      this.price = price;
      return this;
    }

    /**
     * Sale end date.
     * @return value or {@code null} for none
     */
    public com.google.api.client.util.DateTime getSaleEndDate() {
      return saleEndDate;
    }

    /**
     * Sale end date.
     * @param saleEndDate saleEndDate or {@code null} for none
     */
    public Inventories setSaleEndDate(com.google.api.client.util.DateTime saleEndDate) {
      this.saleEndDate = saleEndDate;
      return this;
    }

    /**
     * Sale price of product inventory.
     * @return value or {@code null} for none
     */
    public java.lang.Float getSalePrice() {
      return salePrice;
    }

    /**
     * Sale price of product inventory.
     * @param salePrice salePrice or {@code null} for none
     */
    public Inventories setSalePrice(java.lang.Float salePrice) {
      this.salePrice = salePrice;
      return this;
    }

    /**
     * Sale start date.
     * @return value or {@code null} for none
     */
    public com.google.api.client.util.DateTime getSaleStartDate() {
      return saleStartDate;
    }

    /**
     * Sale start date.
     * @param saleStartDate saleStartDate or {@code null} for none
     */
    public Inventories setSaleStartDate(com.google.api.client.util.DateTime saleStartDate) {
      this.saleStartDate = saleStartDate;
      return this;
    }

    /**
     * Shipping cost of product inventory.
     * @return value or {@code null} for none
     */
    public java.lang.Float getShipping() {
      return shipping;
    }

    /**
     * Shipping cost of product inventory.
     * @param shipping shipping or {@code null} for none
     */
    public Inventories setShipping(java.lang.Float shipping) {
      this.shipping = shipping;
      return this;
    }

    /**
     * Store ID of product inventory.
     * @return value or {@code null} for none
     */
    public java.lang.String getStoreId() {
      return storeId;
    }

    /**
     * Store ID of product inventory.
     * @param storeId storeId or {@code null} for none
     */
    public Inventories setStoreId(java.lang.String storeId) {
      this.storeId = storeId;
      return this;
    }

    /**
     * Tax of product inventory.
     * @return value or {@code null} for none
     */
    public java.lang.Float getTax() {
      return tax;
    }

    /**
     * Tax of product inventory.
     * @param tax tax or {@code null} for none
     */
    public Inventories setTax(java.lang.Float tax) {
      this.tax = tax;
      return this;
    }

    @Override
    public Inventories set(String fieldName, Object value) {
      return (Inventories) super.set(fieldName, value);
    }

    @Override
    public Inventories clone() {
      return (Inventories) super.clone();
    }

  }

  /**
   * Model definition for ShoppingModelProductJsonV1Variants.
   */
  public static final class Variants extends com.google.api.client.json.GenericJson {

    /**
     * The detailed offer data for a particular variant offer.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private ShoppingModelProductJsonV1 variant;

    /**
     * The detailed offer data for a particular variant offer.
     * @return value or {@code null} for none
     */
    public ShoppingModelProductJsonV1 getVariant() {
      return variant;
    }

    /**
     * The detailed offer data for a particular variant offer.
     * @param variant variant or {@code null} for none
     */
    public Variants setVariant(ShoppingModelProductJsonV1 variant) {
      this.variant = variant;
      return this;
    }

    @Override
    public Variants set(String fieldName, Object value) {
      return (Variants) super.set(fieldName, value);
    }

    @Override
    public Variants clone() {
      return (Variants) super.clone();
    }

  }

}
